/*
 *		Sherlock HTML/ASCII Chewer -- Shared Data
 *
 *		(c) 1997--1999 Martin Mares, <mj@atrey.karlin.mff.cuni.cz>
 */

struct entity {
  char *name;
  unsigned int value;
};

const struct entity *is_entity(register const char *, register unsigned int);

#define X2(x,y) (((y) << 8) | (x))
#define X3(x,y,z) (((z) << 16) | ((y) << 8) | (x))

struct tag {
  char *name;
  unsigned int type;
  unsigned int arg;
};

const struct tag *is_tag(register const char *, register unsigned int);

#define T_ON 0
#define T_OFF 1
#define T_WSEP 2
#define T_BASE 3
#define T_META 4
#define T_A 5
#define T_IMG 6
#define T_APPLET 7
#define T_FORM 8
#define T_INPUT 9
#define T_MAP 10
#define T_TITLE 11
#define T_BODY 12
#define T_ISINDEX 13
#define T_LINK 14
#define T_FRAME 15
#define T_BLOCKQUOTE 16

#define A_EM 1
#define A_H1 2
#define A_H2 4
#define A_H3 8
#define A_H4 0x10
#define A_H5 0x20
#define A_H6 0x40
#define A_TT 0x80
#define A_B 0x100
#define A_I 0x200
#define A_TITLE 0x400
#define A_ANCHOR 0x800
#define A_BODY 0x1000
#define A_STRONG 0x2000
#define A_SUP 0x4000
#define A_SUB 0x8000
#define A_CODE 0x10000
#define A_DFN 0x20000
#define A_SAMP 0x40000
#define A_KBD 0x80000
#define A_VAR 0x100000
#define A_ADDRESS 0x200000
#define A_STRIKE 0x400000
#define A_BIG 0x800000
#define A_SMALL 0x1000000
#define A_KEYWORD 0x2000000				/* Listed in META KEYWORDS */
#define A_ACRONYM 0x4000000
#define A_STYLE 0x8000000				/* Style sheet, ignore */
#define A_SCRIPT 0x10000000				/* Embedded script, ignore */
#define A_IS_WS 0x80000000
