/*
 *	Sherlock Library -- Content-Type Filtering
 *
 *	(c) 1997 Martin Mares, <mj@atrey.karlin.mff.cuni.cz>
 */

#include <stdio.h>

#include "lib.h"

struct cfi {
  struct cfi *next;
  byte accept;
  byte pattern[1];
};

struct ct_filter {
  struct cfi *first, **last;
};

struct ct_filter *
new_ct_filter(void)
{
  struct ct_filter *f = xmalloc(sizeof(struct ct_filter));

  f->first = NULL;
  f->last = &f->first;
  return f;
}

byte *
add_ct_filter(struct ct_filter *f, byte *p)
{
  struct cfi *i;

  if (p[0] != '+' && p[0] != '-')
    return "Invalid content-type filter";
  i = xmalloc(sizeof(struct cfi) + strlen(p+1));
  *f->last = i;
  f->last = &i->next;
  i->next = NULL;
  i->accept = (p[0] == '+');
  strcpy(i->pattern, p+1);
  return NULL;
}

/* 0=no, 1=yes, -1=miss */

int
match_ct_filter(struct ct_filter *f, byte *c)
{
  struct cfi *i;

  for(i = f->first; i; i = i->next)
    {
      if (match_ct_patt(i->pattern, c))
	return i->accept;
    }
  return -1;
}
