/*
 *	Sherlock Database Builder -- Dumping of Word Signature SB-Tree
 *
 *	(c) 1997 Martin Mares, <mj@atrey.karlin.mff.cuni.cz>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>

#include <lib/lib.h>
#include <lib/searchdb.h>

static FILE *fi;

static void
dump_pages(void)
{
  struct tree_page pg;

  while (fread(&pg, sizeof(pg), 1, fi))
    {
      uns i, j, k;
      for(i=0; i<KEYS_PER_PAGE; i++)
	{
	  if (pg.keys[i].ptr != (u32) -1)
	    {
	      for(j=0; j<8; j++)
		if (k = pg.keys[i].sig[j])
		  putchar(k);
	      putchar('\n');
	    }
	}
    }
}

int
main(int argc, char **argv)
{
  initlog(argv[0]);
  if (argc != 2)
    die("Usage: dumptree <tree>");
  if (!(fi = fopen(argv[1], "r")))
    die("Unable to open `%s': %m", argv[1]);
  dump_pages();
  return 0;
}
