/*
 *	Sherlock Search Engine -- Query Processing
 *
 *	(c) 1997--1999 Martin Mares, <mj@atrey.karlin.mff.cuni.cz>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <unistd.h>

#include "sherlock.h"

static int obj_fd, oidx_fd;
static oid_t max_oid;

void
show_object(struct query *q, oid_t oid)
{
  uns len, l;
  sh_off_t *z, pos;

  if (oid >= FIRST_PSEUDO_OBJ && show_pseudo_object(q, oid))
    return;
  if (oid >= max_oid)
    {
      add_qr("!Invalid object ID %08x", oid);
      return;
    }
  z = (sh_off_t *) read_data(oidx_fd, oid * sizeof(sh_off_t), &l);
  if (l < sizeof(sh_off_t))
    die("Ugly sh_off_t misalign!");
  pos = *z;
  z = (sh_off_t *) read_data(oidx_fd, (oid+1) * sizeof(sh_off_t), &l);
  if (l < sizeof(sh_off_t))
    die("Ugly sh_off_t misalign!");
  len = *z - pos - 1;
  DDBG("Object %08x at %08x, len=%d", oid, pos, len);

  while (len)
    {
      byte *b = read_data(obj_fd, pos, &l);
      if (l > len)
	l = len;
      reply_string(q, b, l);
      pos += l;
      len -= l;
    }
}

void
objects_init(void)
{
  obj_fd = open_file(obj_pool_name);
  oidx_fd = open_file(obj_idx_name);
  max_oid = lseek(oidx_fd, 0, SEEK_END) / sizeof(sh_off_t) - 1;
  log("Found object pool index with 0x%x objects", max_oid);
}
